﻿using System;
using Infragistics.Windows.Themes;
using System.Windows;
using Infragistics.Windows;
using System.Windows.Controls;

namespace TestThemePack.ResourceSets.OrangePeel
{
    public abstract class MicrosoftResourceSets<T> : ResourceSet where T : ResourceSetLocator, new()
    {
        const string GroupingName = "Microsoft";

        public override string Grouping
        {
            get { return Location.Grouping; }
        }

        public override string Theme
        {
            get { return Location.Theme; }
        }

        public override ResourceDictionary Resources
        {
            get
            {
                return ResourcesInternal;
            }
        }

        private static ResourceSetLocator g_Location;

        // AS 5/7/08
        /// <summary>
        /// Returns the <see cref="ResourceSetLocator"/> that describes the theme information for the resource set.
        /// </summary>
        //private static ResourceSetLocator Location
        public static ResourceSetLocator Location
        {
            get
            {
                if (g_Location == null)
                    g_Location = new T();

                return g_Location;
            }
        }

        private static ResourceDictionary g_ResourcesInternal;

        private static ResourceDictionary ResourcesInternal
        {
            get
            {
                if (g_ResourcesInternal == null)
                {
                    g_ResourcesInternal = Utilities.CreateResourceSetDictionary(Location.Assembly, Location.ResourcePath);
                }

                return g_ResourcesInternal;
            }
        }

        private static Style g_ButtonStyle;

        public static Style ButtonStyle
        {
            get
            {
                if (g_ButtonStyle == null)
                    g_ButtonStyle = ResourceSet.GetSealedResource(ResourcesInternal, typeof(Button)) as Style;

                return g_ButtonStyle;
            }
        }
    }
}
